import poppler

import pdfformfiller.models
import pdb

class PopplerController(object):
    def __init__(self, pdf=""):
        self.doc = poppler.document_new_from_file('file:///home/mark/Bedraga.pdf', password=None)

    def load_poppler_doc(self, filename):
        from django.conf import settings

        pdf_path = os.path.abspath(os.path.join(settings.STATIC_FORMS_ROOT, filename))
        if os.path.isfile(pdf_path):
            return poppler.document_new_from_file('file://' + pdf_path, password=None)


    def generate_page_images(self, pages=[], clear_page=True):
        import cairo
        import StringIO

        page = self.doc.get_page(pages[0] if pages else 0)

        width, height = page.get_size()
        surface = cairo.ImageSurface(cairo.FORMAT_RGB24, int(width*2), int(height*2))
        context = cairo.Context(surface)
        context.scale(2, 2)

        for page_num in pages or xrange(self.doc.get_n_pages()):
            page = self.doc.get_page(page_num)

            if clear_page:
                self.clear_page(page)

            page.render(context)
            fd = StringIO.StringIO()
            surface.write_to_png(fd)
            fd.seek(0)
            yield fd


    def clear_page(self, page):
        for field_mapping in page.get_form_field_mapping():
            field = field_mapping.field
            field_type = field.get_field_type().value_nick

            if field_type == 'text':
                field.text_set_text('')
            elif field_type == 'button':
                field.button_set_state(0)


    def get_page_fields(self, page_num):
        page = self.doc.get_page(page_num)
        for field in page.get_form_field_mapping():
            area = field.area
            data = field.field
            field_type = data.get_field_type()

            if field_type.value_nick == 'text':
                value = data.text_get_text()
            elif field_type.value_nick == 'button':
                value = data.button_get_state()

            yield {
                'name': data.get_name(),
                'value': value,
                'type': field_type.value_nick,
                'area': {
                    'pos_x': area.x1,
                    'pos_y': area.y1,
                    'width': area.x2 - area.x1,
                    'height': area.y2 - area.y1,
                }
            }

class PDFFormFillerPostSave(PopplerController):
    def __init__(self, document):
        pass

